"use strict";
/*
 * Rating.tsx
 * Rating component.
 *
 * Created by Arnold Koh on 5/21/20.
 *
 * dha-rating
 *
 * Copyright © 2009-2019 United States Government as represented by
 * the Program Manager of the DHA: Web and Mobile Technology Program Management Office.
 * All Rights Reserved.
 *
 * Copyright © 2009-2019 Contributors. All Rights Reserved.
 *
 * THIS OPEN SOURCE AGREEMENT ("AGREEMENT") DEFINES THE RIGHTS OF USE,
 * REPRODUCTION, DISTRIBUTION, MODIFICATION AND REDISTRIBUTION OF CERTAIN
 * COMPUTER SOFTWARE ORIGINALLY RELEASED BY THE UNITED STATES GOVERNMENT
 * AS REPRESENTED BY THE GOVERNMENT AGENCY LISTED BELOW ("GOVERNMENT AGENCY").
 * THE UNITED STATES GOVERNMENT, AS REPRESENTED BY GOVERNMENT AGENCY, IS AN
 * INTENDED THIRD-PARTY BENEFICIARY OF ALL SUBSEQUENT DISTRIBUTIONS OR
 * REDISTRIBUTIONS OF THE SUBJECT SOFTWARE. ANYONE WHO USES, REPRODUCES,
 * DISTRIBUTES, MODIFIES OR REDISTRIBUTES THE SUBJECT SOFTWARE, AS DEFINED
 * HEREIN, OR ANY PART THEREOF, IS, BY THAT ACTION, ACCEPTING IN FULL THE
 * RESPONSIBILITIES AND OBLIGATIONS CONTAINED IN THIS AGREEMENT.
 *
 * Government Agency: DHA: Web and Mobile Technology Program Management Office
 * Government Agency Original Software Designation: dha-rating
 * Government Agency Original Software Title: dha-rating
 * User Registration Requested. Please send email
 * with your contact information to: robert.a.kayl.civ@mail.mil
 * Government Agency Point of Contact for Original Software - Program Manager: robert.a.kayl.civ@mail.mil
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Rating = void 0;
var material_1 = require("@mui/material");
var material_2 = require("@mui/material");
var react_1 = __importStar(require("react"));
var Rating = function (_a) {
    var appId = _a.appId;
    var _b = (0, react_1.useState)(''), message = _b[0], setMessage = _b[1];
    var _c = (0, react_1.useState)(0), rating = _c[0], setRating = _c[1];
    var _d = (0, react_1.useState)(''), review = _d[0], setReview = _d[1];
    var _e = (0, react_1.useState)(0), reviewCharCount = _e[0], setReviewCharCount = _e[1];
    var handleRatingChange = function (event, ratingValue) {
        setRating(ratingValue);
    };
    var handleRatingSubmit = function () {
        if (rating || review) {
            fetch("https://wmt-sdk-rating.azurewebsites.us/api/rating/".concat(JSON.stringify({
                appId: appId,
                rating: rating,
                review: review,
            })), {
                method: 'POST',
                headers: {
                    'Content-Type': 'application/json',
                },
            })
                .then(function () {
                setMessage('Review submitted.');
                setRating(0);
                setReview('');
                setReviewCharCount(0);
            })
                .catch(function (error) {
                console.error('Error:', error);
                setMessage('Review not submitted.');
            })
                .finally(function () {
                setTimeout(function () {
                    setMessage('');
                }, 3000);
            });
        }
        else {
            setMessage('Rate or review the app.');
        }
    };
    var handleReviewChange = function (event) {
        var reviewValue = event.target.value;
        setReviewCharCount(reviewValue.length);
        setReview(reviewValue);
    };
    return (react_1.default.createElement(material_1.Grid, { container: true, direction: "column" },
        react_1.default.createElement(material_1.Typography, { component: "legend" }, "Rate the App"),
        react_1.default.createElement(material_2.Rating, { name: "rating", onChange: handleRatingChange, precision: 0.5, value: rating }),
        react_1.default.createElement(material_1.TextField, { sx: {
                margin: function (theme) { return "".concat(theme.spacing(1), " 0"); },
            }, inputProps: { maxLength: 500 }, label: "Write a Review", multiline: true, onChange: handleReviewChange, maxRows: "4", value: review }),
        react_1.default.createElement(material_1.Grid, { container: true, item: true, justifyContent: "space-between" },
            react_1.default.createElement(material_1.Button, { color: "primary", onClick: handleRatingSubmit, size: "small", variant: "contained" }, "Submit"),
            react_1.default.createElement(material_1.Typography, { variant: "caption" },
                reviewCharCount,
                "/500")),
        react_1.default.createElement(material_1.Typography, { sx: {
                marginTop: function (theme) { return theme.spacing(1); },
            }, variant: "caption" }, message)));
};
exports.Rating = Rating;
